# -*- coding: utf-8 -*-

"""
/***************************************************************************
 PTSI
                                 A QGIS plugin
 Calcolo del Preliminary Transplant Suitability Index
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2022-03-01
        copyright            : (C) 2022 by Informamuse S.r.l.
        email                : admin@informamuse.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

__author__ = 'Informamuse S.r.l.'
__date__ = '2022-03-01'
__copyright__ = '(C) 2022 by Informamuse S.r.l.'

# This will get replaced with a git SHA1 when you do a git archive

__revision__ = '$Format:%H$'

import os
import inspect
from qgis.PyQt.QtGui import QIcon

from qgis.core import QgsProcessing
from qgis.core import QgsProcessingAlgorithm
from qgis.core import QgsProcessingMultiStepFeedback
from qgis.core import QgsProcessingParameterRasterLayer
from qgis.core import QgsProcessingParameterRasterDestination
import processing


class PTSIAlgorithm(QgsProcessingAlgorithm):

    def initAlgorithm(self, config=None):
        self.addParameter(QgsProcessingParameterRasterLayer('areadistudio', 'area di studio', defaultValue=None))
        self.addParameter(QgsProcessingParameterRasterLayer('1', 'Parametro A. Distribuzione storica di P. oceanica', defaultValue=None))
        self.addParameter(QgsProcessingParameterRasterLayer('2', 'Parametro B. Attuale distribuzione di P. oceanica', defaultValue=None))
        self.addParameter(QgsProcessingParameterRasterLayer('3', 'Parametro C. Prossimità ad una prateria di P. oceanica', defaultValue=None))
        self.addParameter(QgsProcessingParameterRasterLayer('4', 'Parametro D. Intervallo batimetrico potenziale della prateria', defaultValue=None))
        self.addParameter(QgsProcessingParameterRasterLayer('5', 'Parametro E. Tipologia del substrato', defaultValue=None))
        self.addParameter(QgsProcessingParameterRasterLayer('6', 'Parametro F. Qualità dell’acqua', defaultValue=None))
        self.addParameter(QgsProcessingParameterRasterLayer('7', 'Parametro G. Torbidità', defaultValue=None))
        self.addParameter(QgsProcessingParameterRasterLayer('8', 'Parametro H. Idrodinamismo', defaultValue=None))
        self.addParameter(QgsProcessingParameterRasterDestination('Ptsi', 'PTSI', createByDefault=True, defaultValue=None))

    def processAlgorithm(self, parameters, context, model_feedback):
        # Use a multi-step feedback, so that individual child algorithm progress reports are adjusted for the
        # overall progress through the model
        feedback = QgsProcessingMultiStepFeedback(13, model_feedback)
        results = {}
        outputs = {}

        # Translate B
        alg_params = {
            'COPY_SUBDATASETS': False,
            'DATA_TYPE': 5,
            'EXTRA': '',
            'INPUT': parameters['2'],
            'NODATA': None,
            'OPTIONS': '',
            'TARGET_CRS': parameters['areadistudio'],
            'OUTPUT': QgsProcessing.TEMPORARY_OUTPUT
        }
        outputs['TranslateB'] = processing.run('gdal:translate', alg_params, context=context, feedback=feedback, is_child_algorithm=True)

        feedback.setCurrentStep(1)
        if feedback.isCanceled():
            return {}

        # Translate AREA DI STUDIO
        alg_params = {
            'COPY_SUBDATASETS': False,
            'DATA_TYPE': 5,
            'EXTRA': '',
            'INPUT': parameters['areadistudio'],
            'NODATA': None,
            'OPTIONS': '',
            'TARGET_CRS': parameters['areadistudio'],
            'OUTPUT': QgsProcessing.TEMPORARY_OUTPUT
        }
        outputs['TranslateAreaDiStudio'] = processing.run('gdal:translate', alg_params, context=context, feedback=feedback, is_child_algorithm=True)

        feedback.setCurrentStep(2)
        if feedback.isCanceled():
            return {}

        # Translate C
        alg_params = {
            'COPY_SUBDATASETS': False,
            'DATA_TYPE': 5,
            'EXTRA': '',
            'INPUT': parameters['3'],
            'NODATA': None,
            'OPTIONS': '',
            'TARGET_CRS': parameters['areadistudio'],
            'OUTPUT': QgsProcessing.TEMPORARY_OUTPUT
        }
        outputs['TranslateC'] = processing.run('gdal:translate', alg_params, context=context, feedback=feedback, is_child_algorithm=True)

        feedback.setCurrentStep(3)
        if feedback.isCanceled():
            return {}

        # Translate F
        alg_params = {
            'COPY_SUBDATASETS': False,
            'DATA_TYPE': 5,
            'EXTRA': '',
            'INPUT': parameters['6'],
            'NODATA': None,
            'OPTIONS': '',
            'TARGET_CRS': parameters['areadistudio'],
            'OUTPUT': QgsProcessing.TEMPORARY_OUTPUT
        }
        outputs['TranslateF'] = processing.run('gdal:translate', alg_params, context=context, feedback=feedback, is_child_algorithm=True)

        feedback.setCurrentStep(4)
        if feedback.isCanceled():
            return {}

        # Translate H
        alg_params = {
            'COPY_SUBDATASETS': False,
            'DATA_TYPE': 5,
            'EXTRA': '',
            'INPUT': parameters['8'],
            'NODATA': None,
            'OPTIONS': '',
            'TARGET_CRS': parameters['areadistudio'],
            'OUTPUT': QgsProcessing.TEMPORARY_OUTPUT
        }
        outputs['TranslateH'] = processing.run('gdal:translate', alg_params, context=context, feedback=feedback, is_child_algorithm=True)

        feedback.setCurrentStep(5)
        if feedback.isCanceled():
            return {}

        # Translate D
        alg_params = {
            'COPY_SUBDATASETS': False,
            'DATA_TYPE': 5,
            'EXTRA': '',
            'INPUT': parameters['4'],
            'NODATA': None,
            'OPTIONS': '',
            'TARGET_CRS': parameters['areadistudio'],
            'OUTPUT': QgsProcessing.TEMPORARY_OUTPUT
        }
        outputs['TranslateD'] = processing.run('gdal:translate', alg_params, context=context, feedback=feedback, is_child_algorithm=True)

        feedback.setCurrentStep(6)
        if feedback.isCanceled():
            return {}

        # Translate G
        alg_params = {
            'COPY_SUBDATASETS': False,
            'DATA_TYPE': 5,
            'EXTRA': '',
            'INPUT': parameters['7'],
            'NODATA': None,
            'OPTIONS': '',
            'TARGET_CRS': parameters['areadistudio'],
            'OUTPUT': QgsProcessing.TEMPORARY_OUTPUT
        }
        outputs['TranslateG'] = processing.run('gdal:translate', alg_params, context=context, feedback=feedback, is_child_algorithm=True)

        feedback.setCurrentStep(7)
        if feedback.isCanceled():
            return {}

        # Translate A
        alg_params = {
            'COPY_SUBDATASETS': False,
            'DATA_TYPE': 5,
            'EXTRA': '',
            'INPUT': parameters['1'],
            'NODATA': None,
            'OPTIONS': '',
            'TARGET_CRS': parameters['areadistudio'],
            'OUTPUT': QgsProcessing.TEMPORARY_OUTPUT
        }
        outputs['TranslateA'] = processing.run('gdal:translate', alg_params, context=context, feedback=feedback, is_child_algorithm=True)

        feedback.setCurrentStep(8)
        if feedback.isCanceled():
            return {}

        # Translate E
        alg_params = {
            'COPY_SUBDATASETS': False,
            'DATA_TYPE': 5,
            'EXTRA': '',
            'INPUT': parameters['5'],
            'NODATA': None,
            'OPTIONS': '',
            'TARGET_CRS': parameters['areadistudio'],
            'OUTPUT': QgsProcessing.TEMPORARY_OUTPUT
        }
        outputs['TranslateE'] = processing.run('gdal:translate', alg_params, context=context, feedback=feedback, is_child_algorithm=True)

        feedback.setCurrentStep(9)
        if feedback.isCanceled():
            return {}

        # ABCDE
        alg_params = {
            'BAND_A': 1,
            'BAND_B': 1,
            'BAND_C': 1,
            'BAND_D': 1,
            'BAND_E': 1,
            'BAND_F': 1,
            'EXTRA': '',
            'FORMULA': 'A*B*C*D*E*F',
            'INPUT_A': outputs['TranslateAreaDiStudio']['OUTPUT'],
            'INPUT_B': outputs['TranslateA']['OUTPUT'],
            'INPUT_C': outputs['TranslateB']['OUTPUT'],
            'INPUT_D': outputs['TranslateC']['OUTPUT'],
            'INPUT_E': outputs['TranslateD']['OUTPUT'],
            'INPUT_F': outputs['TranslateE']['OUTPUT'],
            'NO_DATA': None,
            'OPTIONS': '',
            'RTYPE': 4,
            'OUTPUT': QgsProcessing.TEMPORARY_OUTPUT
        }
        outputs['Abcde'] = processing.run('gdal:rastercalculator', alg_params, context=context, feedback=feedback, is_child_algorithm=True)

        feedback.setCurrentStep(10)
        if feedback.isCanceled():
            return {}

        # FGH
        alg_params = {
            'BAND_A': 1,
            'BAND_B': 1,
            'BAND_C': 1,
            'BAND_D': None,
            'BAND_E': None,
            'BAND_F': None,
            'EXTRA': '',
            'FORMULA': 'A*B*C',
            'INPUT_A': outputs['TranslateF']['OUTPUT'],
            'INPUT_B': outputs['TranslateG']['OUTPUT'],
            'INPUT_C': outputs['TranslateH']['OUTPUT'],
            'INPUT_D': None,
            'INPUT_E': None,
            'INPUT_F': None,
            'NO_DATA': None,
            'OPTIONS': '',
            'RTYPE': 4,
            'OUTPUT': QgsProcessing.TEMPORARY_OUTPUT
        }
        outputs['Fgh'] = processing.run('gdal:rastercalculator', alg_params, context=context, feedback=feedback, is_child_algorithm=True)

        feedback.setCurrentStep(11)
        if feedback.isCanceled():
            return {}

        # PTSI
        alg_params = {
            'BAND_A': 1,
            'BAND_B': 1,
            'BAND_C': None,
            'BAND_D': None,
            'BAND_E': None,
            'BAND_F': None,
            'EXTRA': '',
            'FORMULA': 'A*B',
            'INPUT_A': outputs['Abcde']['OUTPUT'],
            'INPUT_B': outputs['Fgh']['OUTPUT'],
            'INPUT_C': None,
            'INPUT_D': None,
            'INPUT_E': None,
            'INPUT_F': None,
            'NO_DATA': None,
            'OPTIONS': '',
            'RTYPE': 4,
            'OUTPUT': parameters['Ptsi']
        }
        outputs['Ptsi'] = processing.run('gdal:rastercalculator', alg_params, context=context, feedback=feedback, is_child_algorithm=True)
        results['Ptsi'] = outputs['Ptsi']['OUTPUT']

        feedback.setCurrentStep(12)
        if feedback.isCanceled():
            return {}

        # Imposta stile layer
        cmd_folder = os.path.split(inspect.getfile(inspect.currentframe()))[0]
        syle_file = os.path.join(os.path.join(cmd_folder, 'stile_ptsi_new.qml'))
        alg_params = {
            'INPUT': outputs['Ptsi']['OUTPUT'],
            'STYLE': syle_file
        }
        outputs['ImpostaStileLayer'] = processing.run('native:setlayerstyle', alg_params, context=context, feedback=feedback, is_child_algorithm=True)
        return results

    def name(self):
        return 'PTSI'

    def displayName(self):
        return 'PTSI'

    def group(self):
        return ''

    def groupId(self):
        return ''

    def shortHelpString(self):
        return """<html><body><h2>Descrizione dell'algoritmo</h2>
<p>Modello per il Calcolo del PTSI</p>
<h2>Parametri in ingresso</h2>
<h3>area di studio</h3>
<p></p>
<h3>Parametro A. Distribuzione storica di P. oceanica</h3>
<p></p>
<h3>Parametro B. Attuale distribuzione di P. oceanica</h3>
<p></p>
<h3>Parametro C. Prossimità ad una prateria di P. oceanica</h3>
<p></p>
<h3>Parametro D. Intervallo batimetrico potenziale della prateria</h3>
<p></p>
<h3>Parametro E. Tipologia del substrato</h3>
<p></p>
<h3>Parametro F. Qualità dell’acqua</h3>
<p></p>
<h3>Parametro G. Torbidità</h3>
<p></p>
<h3>Parametro H. Idrodinamismo</h3>
<p></p>
<h3>PTSI</h3>
<p></p>
<h2>Risultati</h2>
<h3>PTSI</h3>
<p></p>
<br></body></html>"""

    def icon(self):
        cmd_folder = os.path.split(inspect.getfile(inspect.currentframe()))[0]
        icon = QIcon(os.path.join(os.path.join(cmd_folder, 'logo.png')))
        return icon

    def createInstance(self):
        return PTSIAlgorithm()
